/***
 * Excerpted from "HTML5 and CSS3 Second Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/bhh52e for more book information.
***/
/*! H5F - v1.0.0 - 2013-02-01
* https://github.com/ryanseddon/H5F/
* Copyright (c) 2013 Ryan Seddon; Licensed MIT */
var H5F=H5F||{};(function(e){var t=e.createElement("input"),n=/^[a-zA-Z0-9.!#$%&'*+-\/=?\^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/,r=/[a-z][\-\.+a-z]*:\/\//i,i=/^(input|select|textarea)$/i,s,o,u,a,f,l,c,h,p,d,v,m,g,y,b,w,E,S,x,T,N,C,k,L,A;l=function(e,t){var n=!e.nodeType||!1,r={validClass:"valid",invalidClass:"error",requiredClass:"required",placeholderClass:"placeholder"};if(typeof t=="object")for(var i in r)typeof t[i]=="undefined"&&(t[i]=r[i]);f=t||r;if(n)for(var s=0,o=e.length;s<o;s++)c(e[s]);else c(e)},c=function(e){var t=e.elements,n=t.length,r,i=!!e.attributes.novalidate;x(e,"invalid",p,!0),x(e,"blur",p,!0),x(e,"input",p,!0),x(e,"keyup",p,!0),x(e,"focus",p,!0),x(e,"change",p,!0),x(e,"click",d,!0),x(e,"submit",function(t){s=!0,o||!i&&!e.checkValidity()&&N(t)},!1);if(!g()){e.checkValidity=function(){return v(e)};while(n--)r=!!t[n].attributes.required,t[n].nodeName.toLowerCase()!=="fieldset"&&h(t[n])}},h=function(e){var t=e,n=S(t),r={type:t.getAttribute("type"),pattern:t.getAttribute("pattern"),placeholder:t.getAttribute("placeholder")},i=/^(email|url)$/i,s=/^(input|keyup)$/i,o=i.test(r.type)?r.type:r.pattern?r.pattern:!1,u=y(t,o),f=w(t,"step"),l=w(t,"min"),c=w(t,"max"),h=t.validationMessage!==""&&t.validationMessage!==undefined;t.checkValidity=function(){return v.call(this,t)},t.setCustomValidity=function(e){m.call(t,e)},t.validity={valueMissing:n,patternMismatch:u,rangeUnderflow:l,rangeOverflow:c,stepMismatch:f,customError:h,valid:!n&&!u&&!f&&!l&&!c&&!h},r.placeholder&&!s.test(a)&&b(t)},p=function(e){var t=C(e)||e,n=/^(input|keyup|focusin|focus|change)$/i,r=/^(submit|image|button|reset)$/i,s=/^(checkbox|radio)$/i,o=!0;i.test(t.nodeName)&&!r.test(t.type)&&!r.test(t.nodeName)&&(a=e.type,g()||h(t),t.validity.valid&&(t.value!==""||s.test(t.type))||t.value!==t.getAttribute("placeholder")&&t.validity.valid?(L(t,[f.invalidClass,f.requiredClass]),k(t,f.validClass)):n.test(a)?t.validity.valueMissing&&L(t,[f.requiredClass,f.invalidClass,f.validClass]):t.validity.valueMissing?(L(t,[f.invalidClass,f.validClass]),k(t,f.requiredClass)):t.validity.valid||(L(t,[f.validClass,f.requiredClass]),k(t,f.invalidClass)),a==="input"&&o&&(T(t.form,"keyup",p,!0),o=!1))},v=function(e){var t,n,r,i,o=!1;if(e.nodeName.toLowerCase()==="form"){t=e.elements;for(var u=0,a=t.length;u<a;u++)n=t[u],r=!!n.attributes.required,i=!!n.attributes.pattern,n.nodeName.toLowerCase()!=="fieldset"&&(r||i&&r)&&(p(n),!n.validity.valid&&!o&&(s&&n.focus(),o=!0));return!o}return p(e),e.validity.valid},m=function(e){var t=this;t.validationMessage=e},d=function(e){var t=C(e);t.attributes.formnovalidate&&t.type==="submit"&&(o=!0)},g=function(){return A(t,"validity")&&A(t,"checkValidity")},y=function(e,t){if(t==="email")return!n.test(e.value);if(t==="url")return!r.test(e.value);if(!t)return!1;var i=e.getAttribute("placeholder"),s=e.value;return u=new RegExp("^(?:"+t+")$"),s===i?!0:s===""?!1:!u.test(e.value)},b=function(e){var n={placeholder:e.getAttribute("placeholder")},r=/^(focus|focusin|submit)$/i,i=/^(input|textarea)$/i,s=/^password$/i,o="placeholder"in t;!o&&i.test(e.nodeName)&&!s.test(e.type)&&(e.value===""&&!r.test(a)?(e.value=n.placeholder,x(e.form,"submit",function(){a="submit",b(e)},!0),k(e,f.placeholderClass)):e.value===n.placeholder&&r.test(a)&&(e.value="",L(e,f.placeholderClass)))},w=function(e,t){var n=parseInt(e.getAttribute("min"),10)||0,r=parseInt(e.getAttribute("max"),10)||!1,i=parseInt(e.getAttribute("step"),10)||1,s=parseInt(e.value,10),o=(s-n)%i;if(!!S(e)||!!isNaN(s))return e.getAttribute("type")==="number"?!0:!1;if(t==="step")return e.getAttribute("step")?o!==0:!1;if(t==="min")return e.getAttribute("min")?s<n:!1;if(t==="max")return e.getAttribute("max")?s>r:!1},E=function(e){var t=!!e.attributes.required;return t?S(e):!1},S=function(e){var t=e.getAttribute("placeholder"),n=!!e.attributes.required;return!(!n||e.value!==""&&e.value!==t)},x=function(e,t,n,r){A(window,"addEventListener")?e.addEventListener(t,n,r):A(window,"attachEvent")&&typeof window.event!="undefined"&&(t==="blur"?t="focusout":t==="focus"&&(t="focusin"),e.attachEvent("on"+t,n))},T=function(e,t,n,r){A(window,"removeEventListener")?e.removeEventListener(t,n,r):A(window,"detachEvent")&&typeof window.event!="undefined"&&e.detachEvent("on"+t,n)},N=function(e){e=e||window.event,e.stopPropagation&&e.preventDefault?(e.stopPropagation(),e.preventDefault()):(e.cancelBubble=!0,e.returnValue=!1)},C=function(e){return e=e||window.event,e.target||e.srcElement},k=function(e,t){var n;e.className?(n=new RegExp("(^|\\s)"+t+"(\\s|$)"),n.test(e.className)||(e.className+=" "+t)):e.className=t},L=function(e,t){var n,r,i=typeof t=="object"?t.length:1,s=i;if(e.className)if(e.className===t)e.className="";else while(i--)n=new RegExp("(^|\\s)"+(s>1?t[i]:t)+"(\\s|$)"),r=e.className.match(n),r&&r.length===3&&(e.className=e.className.replace(n,r[1]&&r[2]?" ":""))},A=function(e,t){var n=typeof e[t],r=new RegExp("^function|object$","i");return!!(r.test(n)&&e[t]||n==="unknown")},window.H5F={setup:l}})(document);